DEFDBL B-E
PRINT
PRINT "To convert two-column data files (E/A, S)"
PRINT "for one target and one projectile (one A1), relativistically "
PRINT "to be plotted as Fano Plot 10log(L) vs. 10log(E/A)"
PRINT
'Note: the relativistic calculation of beta is correct down to EoverA=1E-7,
'if the projectile mass A1 is entered in u!

INPUT "Enter mass number and element symbol of projectile (e.g.,16, O): "; A1$, Proj$
A1 = VAL(A1$)

OPEN "Projs.lst" FOR INPUT AS #5
DO WHILE NOT EOF(5)                        'Find Z1
        INPUT #5, Z1, ProjList$
        IF Proj$ = ProjList$ THEN EXIT DO
        IF Z1 = 93 THEN PRINT "No projectile name found"
LOOP
CLOSE

OPEN "Masses.lst" FOR INPUT AS #6    'Rest Energies of Projectiles in MeV
INPUT #6, Heading$
DO WHILE NOT EOF(6)
         INPUT #6, Z1L, A1L, E0         'To find E0
         IF Z1L <> Z1 THEN GOTO there:
         IF A1L <> A1 THEN GOTO there:  ELSE EXIT DO
there:  LOOP
CLOSE #6

                                    'To find Z2:
INPUT "Enter element symbol of target (e.g., C, N2, etc.) : "; Targ$
OPEN "Targets.lst" FOR INPUT AS #5
DO WHILE NOT EOF(5)
        INPUT #5, Z2, TargList$
        IF Targ$ = TargList$ THEN EXIT DO
        IF Z2 = 140 THEN PRINT "No target name found"
LOOP
CLOSE

OPEN "atdata.txt" FOR INPUT AS #5        'Find A2
LINE INPUT #5, Heading$
LINE INPUT #5, Heading$
DO WHILE NOT EOF(5)
        INPUT #5, Z, C1, C2, A2, C3, C4  'Find rel. at. mass of natural element
        IF Z = Z2 THEN EXIT DO
LOOP

INPUT "Enter Names of input file and output file (*lg.2a):"; InFile$, OutFile$
OPEN InFile$ FOR INPUT AS #1
OPEN OutFile$ FOR OUTPUT AS #2

M = .4342945#                     'LOG means natural log!      
PRINT "     E           "; InFile$
PRINT #2, "     E           "; InFile$
DO WHILE NOT EOF(1)
        INPUT #1, EoverA, S        'E/A in MeV,S in MeV/(mg/cm2)
        E = E0 + EoverA * A1                'Double Precision!
        beta = SQR(1 - (E0 / E) ^ 2)        'relativistic
        L = S * beta ^ 2 / (.000307075# * Z1 ^ 2 * Z2 / A2)  '.307075 MeVcm2/g, see Berger
        LE = M * LOG(EoverA)
        LL = M * LOG(L)
        PRINT USING "####.#######  "; LE; LL
        PRINT #2, USING "####.#######  "; LE; LL
LOOP
END

